<template>
    <div id="dashboard">
        <section>
            <div class="col1">
                <div class="profile">
                    <h4>Hello {{ userProfile.name }}</h4>
                    <h5>Welcome</h5>
                </div>
            </div>
            <div class="col1">
                <div class="profile">
                    <h4>Avg payments</h4>
                    <h5>{{getAvg}}</h5>
                </div>
            </div>
            <div class="col1">
                <div class="profile">
                    <h5>Max amount: {{getMinMax.max}}</h5>
                    <h5>Min amount: {{getMinMax.min}}</h5>
                </div>
            </div>
        </section>
        <section>
            <div class="col2">
                <transition name="fade">
                    <div v-if="payments.length">
                        <DataTable :data="payments"/>
                    </div>
                    <div v-else>
                        <p class="no-results">There are currently no payments</p>
                    </div>
                </transition>
            </div>
        </section>

    </div>
</template>

<script>
import { mapState } from 'vuex'
import DataTable from './DataTable.vue'

export default {
	data() {
		return {}
	},
	components: {
		DataTable
	},
	computed: {
		...mapState(['userProfile', 'currentUser', 'payments']),
		getAvg() {
			const length = this.payments.length
			let total = 0
			for (var i = 0; i < length; i++) {
				total += this.payments[i].amount
			}
			return (total / length).toFixed(2)
		},
		getMinMax() {
			const min = Math.min.apply(null, this.payments.map(item => item.amount))
			const max = Math.max.apply(null, this.payments.map(item => item.amount))
			return {
				min: min,
				max: max
			}
		}
	}
}
</script>
